<template>
  <header class="header" :class="{ collapsed: isCollapsed }">
    <div v-if="!isHidden" class="header__left">
      <switch-modern-theme :is-dark="isDark" @toggle="toggleDarkMode" />
    </div>
    <div class="header__right">
      <div v-if="!facebook.IsHidden && facebook.IsHidden !== undefined" class="flex w-full gap-3">
        <nuxt-link
          :to="facebook.HyperLink"
          class="cursor-pointer px-4 py-1 btn-fb border border-[#4857E5] flex justify-center items-center relative"
          target="_blank"
        >
          <div>
            <img :src="getAssetImage(`assets/theme/common/icon/facebook.gif`)" class="w-[80px] h-[16px]">
          </div>
          <div class="star-icon absolute">
            <img :src="getAssetImage(`assets/theme/common/icon/star.gif`)" class="w-[24px] h-[24px]">
          </div>
        </nuxt-link>
      </div>
      <div v-if="!authenticated" class="flex w-full gap-3">
        <nuxt-link to="/login" class="button-login whitespace-nowrap">
          <Button>
            <span>{{ $t("capital_login") }}</span>
          </Button>
        </nuxt-link>
        <nuxt-link
          v-if="!register.IsHidden"
          to="/register"
          class="button--t4 whitespace-nowrap"
          :id="ID.SIGNUP"
        >
          <Button variant="Accent" class="pointer-events-none">
            <span>{{ $t("joinnow") }}</span>
          </Button>
        </nuxt-link>
        <nuxt-link
          v-if="!agentCooperation.IsHidden"
          to="/agent-cooperation"
          class="button--t4 whitespace-nowrap"
        >
          <Button variant="Accent">
            <span>{{ $t("agent_cooperation") }}</span>
          </Button>
        </nuxt-link>
      </div>
      <div v-else class="flex w-full gap-5 text-[var(--text2)]">
        <div class="flex gap-2">
          <nuxt-link
            v-if="isShowDepositWithdrawal && isCashPlayer"
            to="/deposit"
            class="header-user__transactions flex items-center justify-center w-[40px] h-[40px] rounded-[6px]"
          >
            <img
              class="w-[24px] h-[24px]"
              :src="
                getAssetImage(
                  `assets/theme/black_modern_1/images/profileMenu/deposit.svg`
                )
              "
            />
          </nuxt-link>
          <balance-info-component :is-suspended="isSuspendedAccount" />
        </div>
        <div class="flex gap-2 cursor-pointer">
          <el-dropdown trigger="click" popper-class="bmd1-dropdown">
            <div class="el-dropdown-link flex gap-2">
              <div class="user-avatar">
                <img
                  class="w-full h-full"
                  :src="
                    getAssetImage(
                      `assets/theme/black_modern_1/images/profileMenu/avatar.svg`
                    )
                  "
                />
              </div>
              <div class="text-[var(--text2)]">
                <div class="uppercase h-[20px] flex items-center">
                  {{ $t("id") }}: {{ customerId }}
                </div>
                <div class="h-[20px] flex items-center gap-1">
                  <span>{{ username }}</span>
                  <font-awesome-icon icon="play" class="text-[var(--text2)]" />
                </div>
              </div>
              <el-icon class="el-icon--right"><arrow-down /></el-icon>
            </div>
            <template #dropdown>
              <el-dropdown-menu class="user-info-background">
                <el-dropdown-item
                  v-if="isShowDepositWithdrawal && isCashPlayer"
                >
                  <nuxt-link to="/deposit">
                    <div class="user-info-item mb-[15px]">
                      {{ $t(`deposit${isBhinbhin}`) }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item
                  v-if="isShowDepositWithdrawal && isCashPlayer"
                >
                  <nuxt-link to="/withdrawal">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("withdrawal") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <nuxt-link :to="ROUTES.ACCOUNT.INFO">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("account") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <nuxt-link to="/profile">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("profile") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <nuxt-link to="/wallet">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("balance") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <nuxt-link :to="BET_HISTORY_ROUTES.INDEX">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("bet_history") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <nuxt-link to="/transaction-history/winlose">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("statement") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item v-if="referralEnabled && !isV2ReferralEnabled && isShowReferralPage">
                  <nuxt-link to="/referral">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("referral") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item v-if="isReferralV2Enabled && isShowReferralPage">
                  <nuxt-link to="/referral-v2/information">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("referral") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item v-if="!agentCooperation.IsHidden">
                  <nuxt-link to="/agent-cooperation">
                    <div class="user-info-item mb-[15px]">
                      {{ $t("agent_cooperation") }}
                    </div>
                  </nuxt-link>
                </el-dropdown-item>
                <el-dropdown-item>
                  <div class="user-info-item" @click="onLogout">
                    {{ $t("logout") }}
                  </div>
                </el-dropdown-item>
              </el-dropdown-menu>
            </template>
          </el-dropdown>
        </div>
      </div>
    </div>
  </header>
</template>

<script setup lang="ts">
import { computed } from "vue";
import commonHelper from "@/utils/commonHelper";
import { useHeaderComponent } from "@/composables/useTheme";
import useMenu from "@/composables/useMenu";
import { store } from "~~/store";
import { appStore } from '~~/store/app';
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

defineProps({
  isCollapsed: {
    type: Boolean,
    required: true,
  },
  isDark: {
    type: Boolean,
    required: true,
  },
  isHidden: {
    type: Boolean,
    default: false,
  },
});
const emit = defineEmits(["toggle"]);
const toggleDarkMode = () => {
  emit("toggle");
};
const authenticated = computed(() => store.state.auth);
const { getAssetImage, isBhinbhin } = commonHelper;
const customerId = computed(() => store.state.customerId);
const username = computed(() => store.state.username);
const {
  logout,
  referralEnabled,
  agentCooperation,
  isSuspendedAccount,
  register,
  isReferralV2Enabled,
} = useHeaderComponent();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const onLogout = () => {
  logout();
};
const { isShowDepositWithdrawal, isCashPlayer } = useMenu();
const facebook = computed(() =>
  featuresToggleHelper.getThemePropertyFromApi(
    EnumThemePropertyKey.HtmlId,
    "facebook_link"
  )
);

</script>

<style scoped lang="scss">
.header {
  background-color: var(--background3);
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: calc(100% - 288px);
  height: 72px;
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  border-bottom: 1px solid var(--border-color);
  z-index: 21;
  margin-left: 288px;
  padding-left: 32px !important;
  padding-right: 32px !important;

  &.collapsed {
    margin-left: 72px;
    width: calc(100% - 72px);
  }

  &__right {
    display: flex;
    gap: 0.75rem;
  }
}
.header-user__transactions {
  background: var(--primary);
  border: 2px solid var(--button-bg);
  box-shadow: var(--box-shadow);
  transition: all 0.5s;
}
.user-avatar {
  display: block;
  width: 40px;
  height: 40px;
  transition: all 0.4s;
  border: 2px solid var(--button-bg);
  box-shadow: var(--box-shadow);
  border-radius: 20px;
  overflow: hidden;
}
.el-dropdown-menu {
  background-color: var(--button-bg);
  border-radius: 2px;
  padding: 15px 24px;
  width: 230px;
  box-shadow: var(--box-shadow);
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}
:deep(.el-popper__arrow::before) {
  background: unset;
}
:deep(.el-dropdown-menu__item) {
  padding: unset;
}
:deep(.el-dropdown-menu__item:hover) {
  background: unset;
}
.user-info-item {
  text-transform: uppercase;
  background-color: var(--button-bg);
  box-shadow: var(--box-shadow);
  width: 176px;
  height: 40px;
  color: var(--text2);
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 8px;
}
:deep(.el-popper__arrow::before) {
  background: var(--button-bg);
}
.btn-login {
  width: 100%;
  color: var(--textBtn);
  background-color: var(--button-bg);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 12px;
  -webkit-transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s, -webkit-box-shadow 0.4s;
}
.star-icon {
  right: -13px;
}
</style>
<style>
.el-popper.el-dropdown__popper.bmd1-dropdown {
  background: var(--background2);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 8px;
}
</style>
